/*S2IBIS Version 1.0 - Steven Lipa, NC State University  August 4, 1994       */

/******************************************************************************/
/*  Copyright 1994, North Carolina State University.                          */
/*                                                                            */
/*  North Carolina State University (NCSU) and the author hereby disclaim     */
/*  all implied warranties, including the implied warranties of merchant-     */
/*  ability and fitness for a particular purpose. NCSU is not liable for      */
/*  any damages incurred by the use of this software and/or documentation,    */
/*  including direct, indirect, special, incidental, or consequential         */
/*  damages.                                                                  */
/*                                                                            */
/*  NCSU grants the bearer the right to modify, copy, and redistribute        */
/*  this software and documentation, but requests that NCSU be acknowledged   */
/*  for its contribution in the resulting product.                            */
/******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <time.h>


#define MODEL_TYPE_LENGTH         (20+1)   /* Add 1 for null terminator */
#define MODEL_NAME_LENGTH         (20+1)   /* Add 1 for null terminator */
#define R_PIN_NAME_LENGTH         (10+1)   /* Add 1 for null terminator */
#define L_PIN_NAME_LENGTH         (10+1)   /* Add 1 for null terminator */
#define C_PIN_NAME_LENGTH         (10+1)   /* Add 1 for null terminator */
#define SIGNAL_NAME_LENGTH        (20+1)   /* Add 1 for null terminator */
#define PIN_NAME_LENGTH           (5+1)    /* Add 1 for null terminator */
#define SPICE_FILE_NAME_LENGTH    (12+1)   /* Add 1 for null terminator */
#define TEXT_LENGTH               (80+1+1) /* add one for the null terminator
					    * and one for the asterisk that
					    * uses prepend to a line to appear
					    * in the ibis file.  That's right,
					    * the input to ibis can be a line
					    * of 81 characters but the line
					    * will be 81 characters when it is
					    * printed out in the ibis file. */
#define SPICE_NODE_NAME_LENGTH    (256+1)  /* not defined in spec */
#define ENABLE_NAME_LENGTH        (6+1)    /* not defined in spec */
#define ENABLE_TEXT_LENGTH        TEXT_LENGTH /* not defined in spec */
#define C_COMP_LENGTH             TEXT_LENGTH /* not defined in spec */
#define VINH_LENGTH               TEXT_LENGTH /* not defined in spec */
#define VINL_LENGTH               TEXT_LENGTH /* not defined in spec */
#define POLAR_TEXT_LENGTH         TEXT_LENGTH /* not defined in spec */

#define PMODE 0755

#define ISNOTWHITE(A) ((A!=' ')&&(A!='\n')&&(A!='\0')&&(A!='\t')&&(A!='\r')&&(A!='\f'))
#define ISWHITE(A) ((A==' ')||(A=='\n')||(A=='\0')||(A=='\t')||(A=='\r')||(A=='\f'))
#define ISWHITEONLINE(A) ((A==' ')||(A=='\0')||(A=='\t'))

typedef struct pinentry { struct pinentry *lastlink;
                          char pin[PIN_NAME_LENGTH];
                          char spice_node[SPICE_NODE_NAME_LENGTH];
                          char signal_name[SIGNAL_NAME_LENGTH];
                          char model_name[MODEL_NAME_LENGTH];
                          char R_pin[R_PIN_NAME_LENGTH];
                          char L_pin[L_PIN_NAME_LENGTH];
                          char C_pin[C_PIN_NAME_LENGTH];
                          int  model_type;
                          int  polarity;
                          int  show_polarity;
                          char polartext[POLAR_TEXT_LENGTH];
                          char inpin[PIN_NAME_LENGTH];
                          float vil;
                          float vih;
                          float vpwr_max;
                          float vpwr_typ;
                          float vpwr_min;
                          char  enable[ENABLE_NAME_LENGTH];
                          int   show_enable;
                          char  enabletext[ENABLE_TEXT_LENGTH];
                          float  forceto;
                          double  ramp_sim_time;
                          char c_comp[C_COMP_LENGTH];
                          char Vinh[VINH_LENGTH];
                          char Vinl[VINL_LENGTH];
                          float  vihrt;
                          float  vihrn;
                          float  vihrx;
                          float  vilrt;
                          float  vilrn;
                          float  vilrx;
                          double trt;
                          double trn;
                          double trx;
                          double tft;
                          double tfn;
                          double tfx;
                          int    no_model;
                          struct pinentry *nextlink;
 		        }PINELEM,*PINPTR;


typedef struct modentry { struct modentry *lastlink;
                          char model_name[MODEL_NAME_LENGTH];
                          struct modentry *nextlink;
                        }MODELEM,*MODPTR;

typedef struct nodeentry { struct nodeentry *lastlink;
                          char snode[ENABLE_NAME_LENGTH];
                          struct nodeentry *nextlink;
                        }NODEELEM,*NODEPTR;

typedef struct textentry { struct textentry *lastlink;
                          char textline[TEXT_LENGTH];
                          struct textentry *nextlink;
                        }TEXTELEM,*TEXTPTR;

void strncpyWarn( char * s1, char *s2, size_t n);
